t / test-lib.shon commit t4150 (am): style fix (800f110)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset GIT_EDITOR
  47unset AUTHOR_DATE
  48unset AUTHOR_EMAIL
  49unset AUTHOR_NAME
  50unset COMMIT_AUTHOR_EMAIL
  51unset COMMIT_AUTHOR_NAME
  52unset EMAIL
  53unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  54unset GIT_AUTHOR_DATE
  55GIT_AUTHOR_EMAIL=author@example.com
  56GIT_AUTHOR_NAME='A U Thor'
  57unset GIT_COMMITTER_DATE
  58GIT_COMMITTER_EMAIL=committer@example.com
  59GIT_COMMITTER_NAME='C O Mitter'
  60unset GIT_DIFF_OPTS
  61unset GIT_DIR
  62unset GIT_WORK_TREE
  63unset GIT_EXTERNAL_DIFF
  64unset GIT_INDEX_FILE
  65unset GIT_OBJECT_DIRECTORY
  66unset GIT_CEILING_DIRECTORIES
  67unset SHA1_FILE_DIRECTORIES
  68unset SHA1_FILE_DIRECTORY
  69unset GIT_NOTES_REF
  70unset GIT_NOTES_DISPLAY_REF
  71unset GIT_NOTES_REWRITE_REF
  72unset GIT_NOTES_REWRITE_MODE
  73GIT_MERGE_VERBOSITY=5
  74export GIT_MERGE_VERBOSITY
  75export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  76export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  77export EDITOR
  78
  79# Protect ourselves from common misconfiguration to export
  80# CDPATH into the environment
  81unset CDPATH
  82
  83unset GREP_OPTIONS
  84
  85case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  86        1|2|true)
  87                echo "* warning: Some tests will not work if GIT_TRACE" \
  88                        "is set as to trace on STDERR ! *"
  89                echo "* warning: Please set GIT_TRACE to something" \
  90                        "other than 1, 2 or true ! *"
  91                ;;
  92esac
  93
  94# Convenience
  95#
  96# A regexp to match 5 and 40 hexdigits
  97_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  98_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  99
 100# Each test should start with something like this, after copyright notices:
 101#
 102# test_description='Description of this test...
 103# This test checks if command xyzzy does the right thing...
 104# '
 105# . ./test-lib.sh
 106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 107                TERM=$ORIGINAL_TERM &&
 108                export TERM &&
 109                [ -t 1 ] &&
 110                tput bold >/dev/null 2>&1 &&
 111                tput setaf 1 >/dev/null 2>&1 &&
 112                tput sgr0 >/dev/null 2>&1
 113        ) &&
 114        color=t
 115
 116while test "$#" -ne 0
 117do
 118        case "$1" in
 119        -d|--d|--de|--deb|--debu|--debug)
 120                debug=t; shift ;;
 121        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 122                immediate=t; shift ;;
 123        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 124                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 125        -h|--h|--he|--hel|--help)
 126                help=t; shift ;;
 127        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 128                verbose=t; shift ;;
 129        -q|--q|--qu|--qui|--quie|--quiet)
 130                quiet=t; shift ;;
 131        --with-dashes)
 132                with_dashes=t; shift ;;
 133        --no-color)
 134                color=; shift ;;
 135        --no-python)
 136                # noop now...
 137                shift ;;
 138        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 139                valgrind=t; verbose=t; shift ;;
 140        --tee)
 141                shift ;; # was handled already
 142        --root=*)
 143                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 144                shift ;;
 145        *)
 146                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 147        esac
 148done
 149
 150if test -n "$color"; then
 151        say_color () {
 152                (
 153                TERM=$ORIGINAL_TERM
 154                export TERM
 155                case "$1" in
 156                        error) tput bold; tput setaf 1;; # bold red
 157                        skip)  tput bold; tput setaf 2;; # bold green
 158                        pass)  tput setaf 2;;            # green
 159                        info)  tput setaf 3;;            # brown
 160                        *) test -n "$quiet" && return;;
 161                esac
 162                shift
 163                printf "%s" "$*"
 164                tput sgr0
 165                echo
 166                )
 167        }
 168else
 169        say_color() {
 170                test -z "$1" && test -n "$quiet" && return
 171                shift
 172                echo "$*"
 173        }
 174fi
 175
 176error () {
 177        say_color error "error: $*"
 178        GIT_EXIT_OK=t
 179        exit 1
 180}
 181
 182say () {
 183        say_color info "$*"
 184}
 185
 186test "${test_description}" != "" ||
 187error "Test script did not set test_description."
 188
 189if test "$help" = "t"
 190then
 191        echo "$test_description"
 192        exit 0
 193fi
 194
 195exec 5>&1
 196if test "$verbose" = "t"
 197then
 198        exec 4>&2 3>&1
 199else
 200        exec 4>/dev/null 3>/dev/null
 201fi
 202
 203test_failure=0
 204test_count=0
 205test_fixed=0
 206test_broken=0
 207test_success=0
 208
 209test_external_has_tap=0
 210
 211die () {
 212        code=$?
 213        if test -n "$GIT_EXIT_OK"
 214        then
 215                exit $code
 216        else
 217                echo >&5 "FATAL: Unexpected exit with code $code"
 218                exit 1
 219        fi
 220}
 221
 222GIT_EXIT_OK=
 223trap 'die' EXIT
 224
 225# The semantics of the editor variables are that of invoking
 226# sh -c "$EDITOR \"$@\"" files ...
 227#
 228# If our trash directory contains shell metacharacters, they will be
 229# interpreted if we just set $EDITOR directly, so do a little dance with
 230# environment variables to work around this.
 231#
 232# In particular, quoting isn't enough, as the path may contain the same quote
 233# that we're using.
 234test_set_editor () {
 235        FAKE_EDITOR="$1"
 236        export FAKE_EDITOR
 237        EDITOR='"$FAKE_EDITOR"'
 238        export EDITOR
 239}
 240
 241test_decode_color () {
 242        sed     -e 's/.\[1m/<WHITE>/g' \
 243                -e 's/.\[31m/<RED>/g' \
 244                -e 's/.\[32m/<GREEN>/g' \
 245                -e 's/.\[33m/<YELLOW>/g' \
 246                -e 's/.\[34m/<BLUE>/g' \
 247                -e 's/.\[35m/<MAGENTA>/g' \
 248                -e 's/.\[36m/<CYAN>/g' \
 249                -e 's/.\[m/<RESET>/g'
 250}
 251
 252q_to_nul () {
 253        perl -pe 'y/Q/\000/'
 254}
 255
 256q_to_cr () {
 257        tr Q '\015'
 258}
 259
 260q_to_tab () {
 261        tr Q '\011'
 262}
 263
 264append_cr () {
 265        sed -e 's/$/Q/' | tr Q '\015'
 266}
 267
 268remove_cr () {
 269        tr '\015' Q | sed -e 's/Q$//'
 270}
 271
 272test_tick () {
 273        if test -z "${test_tick+set}"
 274        then
 275                test_tick=1112911993
 276        else
 277                test_tick=$(($test_tick + 60))
 278        fi
 279        GIT_COMMITTER_DATE="$test_tick -0700"
 280        GIT_AUTHOR_DATE="$test_tick -0700"
 281        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 282}
 283
 284# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 285#
 286# This will commit a file with the given contents and the given commit
 287# message.  It will also add a tag with <message> as name.
 288#
 289# Both <file> and <contents> default to <message>.
 290
 291test_commit () {
 292        file=${2:-"$1.t"}
 293        echo "${3-$1}" > "$file" &&
 294        git add "$file" &&
 295        test_tick &&
 296        git commit -m "$1" &&
 297        git tag "$1"
 298}
 299
 300# Call test_merge with the arguments "<message> <commit>", where <commit>
 301# can be a tag pointing to the commit-to-merge.
 302
 303test_merge () {
 304        test_tick &&
 305        git merge -m "$1" "$2" &&
 306        git tag "$1"
 307}
 308
 309# This function helps systems where core.filemode=false is set.
 310# Use it instead of plain 'chmod +x' to set or unset the executable bit
 311# of a file in the working directory and add it to the index.
 312
 313test_chmod () {
 314        chmod "$@" &&
 315        git update-index --add "--chmod=$@"
 316}
 317
 318# Use test_set_prereq to tell that a particular prerequisite is available.
 319# The prerequisite can later be checked for in two ways:
 320#
 321# - Explicitly using test_have_prereq.
 322#
 323# - Implicitly by specifying the prerequisite tag in the calls to
 324#   test_expect_{success,failure,code}.
 325#
 326# The single parameter is the prerequisite tag (a simple word, in all
 327# capital letters by convention).
 328
 329test_set_prereq () {
 330        satisfied="$satisfied$1 "
 331}
 332satisfied=" "
 333
 334test_have_prereq () {
 335        case $satisfied in
 336        *" $1 "*)
 337                : yes, have it ;;
 338        *)
 339                ! : nope ;;
 340        esac
 341}
 342
 343# You are not expected to call test_ok_ and test_failure_ directly, use
 344# the text_expect_* functions instead.
 345
 346test_ok_ () {
 347        test_success=$(($test_success + 1))
 348        say_color "" "ok $test_count - $@"
 349}
 350
 351test_failure_ () {
 352        test_failure=$(($test_failure + 1))
 353        say_color error "not ok - $test_count $1"
 354        shift
 355        echo "$@" | sed -e 's/^/#       /'
 356        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 357}
 358
 359test_known_broken_ok_ () {
 360        test_fixed=$(($test_fixed+1))
 361        say_color "" "ok $test_count - $@ # TODO known breakage"
 362}
 363
 364test_known_broken_failure_ () {
 365        test_broken=$(($test_broken+1))
 366        say_color skip "not ok $test_count - $@ # TODO known breakage"
 367}
 368
 369test_debug () {
 370        test "$debug" = "" || eval "$1"
 371}
 372
 373test_run_ () {
 374        test_cleanup=:
 375        eval >&3 2>&4 "$1"
 376        eval_ret=$?
 377        eval >&3 2>&4 "$test_cleanup"
 378        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 379                echo ""
 380        fi
 381        return 0
 382}
 383
 384test_skip () {
 385        test_count=$(($test_count+1))
 386        to_skip=
 387        for skp in $GIT_SKIP_TESTS
 388        do
 389                case $this_test.$test_count in
 390                $skp)
 391                        to_skip=t
 392                        break
 393                esac
 394        done
 395        if test -z "$to_skip" && test -n "$prereq" &&
 396           ! test_have_prereq "$prereq"
 397        then
 398                to_skip=t
 399        fi
 400        case "$to_skip" in
 401        t)
 402                say_color skip >&3 "skipping test: $@"
 403                say_color skip "ok $test_count # skip $1"
 404                : true
 405                ;;
 406        *)
 407                false
 408                ;;
 409        esac
 410}
 411
 412test_expect_failure () {
 413        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 414        test "$#" = 2 ||
 415        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 416        if ! test_skip "$@"
 417        then
 418                say >&3 "checking known breakage: $2"
 419                test_run_ "$2"
 420                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 421                then
 422                        test_known_broken_ok_ "$1"
 423                else
 424                        test_known_broken_failure_ "$1"
 425                fi
 426        fi
 427        echo >&3 ""
 428}
 429
 430test_expect_success () {
 431        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 432        test "$#" = 2 ||
 433        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 434        if ! test_skip "$@"
 435        then
 436                say >&3 "expecting success: $2"
 437                test_run_ "$2"
 438                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 439                then
 440                        test_ok_ "$1"
 441                else
 442                        test_failure_ "$@"
 443                fi
 444        fi
 445        echo >&3 ""
 446}
 447
 448test_expect_code () {
 449        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 450        test "$#" = 3 ||
 451        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
 452        if ! test_skip "$@"
 453        then
 454                say >&3 "expecting exit code $1: $3"
 455                test_run_ "$3"
 456                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 457                then
 458                        test_ok_ "$2"
 459                else
 460                        test_failure_ "$@"
 461                fi
 462        fi
 463        echo >&3 ""
 464}
 465
 466# test_external runs external test scripts that provide continuous
 467# test output about their progress, and succeeds/fails on
 468# zero/non-zero exit code.  It outputs the test output on stdout even
 469# in non-verbose mode, and announces the external script with "# run
 470# <n>: ..." before running it.  When providing relative paths, keep in
 471# mind that all scripts run in "trash directory".
 472# Usage: test_external description command arguments...
 473# Example: test_external 'Perl API' perl ../path/to/test.pl
 474test_external () {
 475        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 476        test "$#" = 3 ||
 477        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 478        descr="$1"
 479        shift
 480        if ! test_skip "$descr" "$@"
 481        then
 482                # Announce the script to reduce confusion about the
 483                # test output that follows.
 484                say_color "" "# run $test_count: $descr ($*)"
 485                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 486                # to be able to use them in script
 487                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 488                # Run command; redirect its stderr to &4 as in
 489                # test_run_, but keep its stdout on our stdout even in
 490                # non-verbose mode.
 491                "$@" 2>&4
 492                if [ "$?" = 0 ]
 493                then
 494                        if test $test_external_has_tap -eq 0; then
 495                                test_ok_ "$descr"
 496                        else
 497                                say_color "" "# test_external test $descr was ok"
 498                                test_success=$(($test_success + 1))
 499                        fi
 500                else
 501                        if test $test_external_has_tap -eq 0; then
 502                                test_failure_ "$descr" "$@"
 503                        else
 504                                say_color error "# test_external test $descr failed: $@"
 505                                test_failure=$(($test_failure + 1))
 506                        fi
 507                fi
 508        fi
 509}
 510
 511# Like test_external, but in addition tests that the command generated
 512# no output on stderr.
 513test_external_without_stderr () {
 514        # The temporary file has no (and must have no) security
 515        # implications.
 516        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 517        stderr="$tmp/git-external-stderr.$$.tmp"
 518        test_external "$@" 4> "$stderr"
 519        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 520        descr="no stderr: $1"
 521        shift
 522        say >&3 "# expecting no stderr from previous command"
 523        if [ ! -s "$stderr" ]; then
 524                rm "$stderr"
 525
 526                if test $test_external_has_tap -eq 0; then
 527                        test_ok_ "$descr"
 528                else
 529                        say_color "" "# test_external_without_stderr test $descr was ok"
 530                        test_success=$(($test_success + 1))
 531                fi
 532        else
 533                if [ "$verbose" = t ]; then
 534                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 535                else
 536                        output=
 537                fi
 538                # rm first in case test_failure exits.
 539                rm "$stderr"
 540                if test $test_external_has_tap -eq 0; then
 541                        test_failure_ "$descr" "$@" "$output"
 542                else
 543                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 544                        test_failure=$(($test_failure + 1))
 545                fi
 546        fi
 547}
 548
 549# This is not among top-level (test_expect_success | test_expect_failure)
 550# but is a prefix that can be used in the test script, like:
 551#
 552#       test_expect_success 'complain and die' '
 553#           do something &&
 554#           do something else &&
 555#           test_must_fail git checkout ../outerspace
 556#       '
 557#
 558# Writing this as "! git checkout ../outerspace" is wrong, because
 559# the failure could be due to a segv.  We want a controlled failure.
 560
 561test_must_fail () {
 562        "$@"
 563        test $? -gt 0 -a $? -le 129 -o $? -gt 192
 564}
 565
 566# Similar to test_must_fail, but tolerates success, too.  This is
 567# meant to be used in contexts like:
 568#
 569#       test_expect_success 'some command works without configuration' '
 570#               test_might_fail git config --unset all.configuration &&
 571#               do something
 572#       '
 573#
 574# Writing "git config --unset all.configuration || :" would be wrong,
 575# because we want to notice if it fails due to segv.
 576
 577test_might_fail () {
 578        "$@"
 579        test $? -ge 0 -a $? -le 129 -o $? -gt 192
 580}
 581
 582# test_cmp is a helper function to compare actual and expected output.
 583# You can use it like:
 584#
 585#       test_expect_success 'foo works' '
 586#               echo expected >expected &&
 587#               foo >actual &&
 588#               test_cmp expected actual
 589#       '
 590#
 591# This could be written as either "cmp" or "diff -u", but:
 592# - cmp's output is not nearly as easy to read as diff -u
 593# - not all diff versions understand "-u"
 594
 595test_cmp() {
 596        $GIT_TEST_CMP "$@"
 597}
 598
 599# This function can be used to schedule some commands to be run
 600# unconditionally at the end of the test to restore sanity:
 601#
 602#       test_expect_success 'test core.capslock' '
 603#               git config core.capslock true &&
 604#               test_when_finished "git config --unset core.capslock" &&
 605#               hello world
 606#       '
 607#
 608# That would be roughly equivalent to
 609#
 610#       test_expect_success 'test core.capslock' '
 611#               git config core.capslock true &&
 612#               hello world
 613#               git config --unset core.capslock
 614#       '
 615#
 616# except that the greeting and config --unset must both succeed for
 617# the test to pass.
 618
 619test_when_finished () {
 620        test_cleanup="{ $*
 621                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 622}
 623
 624# Most tests can use the created repository, but some may need to create more.
 625# Usage: test_create_repo <directory>
 626test_create_repo () {
 627        test "$#" = 1 ||
 628        error "bug in the test script: not 1 parameter to test-create-repo"
 629        owd=`pwd`
 630        repo="$1"
 631        mkdir -p "$repo"
 632        cd "$repo" || error "Cannot setup test environment"
 633        "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
 634        error "cannot run git init -- have you built things yet?"
 635        mv .git/hooks .git/hooks-disabled
 636        cd "$owd"
 637}
 638
 639test_done () {
 640        GIT_EXIT_OK=t
 641        test_results_dir="$TEST_DIRECTORY/test-results"
 642        mkdir -p "$test_results_dir"
 643        test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 644
 645        echo "total $test_count" >> $test_results_path
 646        echo "success $test_success" >> $test_results_path
 647        echo "fixed $test_fixed" >> $test_results_path
 648        echo "broken $test_broken" >> $test_results_path
 649        echo "failed $test_failure" >> $test_results_path
 650        echo "" >> $test_results_path
 651
 652        if test "$test_fixed" != 0
 653        then
 654                say_color pass "# fixed $test_fixed known breakage(s)"
 655        fi
 656        if test "$test_broken" != 0
 657        then
 658                say_color error "# still have $test_broken known breakage(s)"
 659                msg="remaining $(($test_count-$test_broken)) test(s)"
 660        else
 661                msg="$test_count test(s)"
 662        fi
 663        case "$test_failure" in
 664        0)
 665                # Maybe print SKIP message
 666                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 667
 668                if test $test_external_has_tap -eq 0; then
 669                        say_color pass "# passed all $msg"
 670                        say "1..$test_count$skip_all"
 671                fi
 672
 673                test -d "$remove_trash" &&
 674                cd "$(dirname "$remove_trash")" &&
 675                rm -rf "$(basename "$remove_trash")"
 676
 677                exit 0 ;;
 678
 679        *)
 680                if test $test_external_has_tap -eq 0; then
 681                        say_color error "# failed $test_failure among $msg"
 682                        say "1..$test_count"
 683                fi
 684
 685                exit 1 ;;
 686
 687        esac
 688}
 689
 690# Test the binaries we have just built.  The tests are kept in
 691# t/ subdirectory and are run in 'trash directory' subdirectory.
 692TEST_DIRECTORY=$(pwd)
 693if test -n "$valgrind"
 694then
 695        make_symlink () {
 696                test -h "$2" &&
 697                test "$1" = "$(readlink "$2")" || {
 698                        # be super paranoid
 699                        if mkdir "$2".lock
 700                        then
 701                                rm -f "$2" &&
 702                                ln -s "$1" "$2" &&
 703                                rm -r "$2".lock
 704                        else
 705                                while test -d "$2".lock
 706                                do
 707                                        say "Waiting for lock on $2."
 708                                        sleep 1
 709                                done
 710                        fi
 711                }
 712        }
 713
 714        make_valgrind_symlink () {
 715                # handle only executables
 716                test -x "$1" || return
 717
 718                base=$(basename "$1")
 719                symlink_target=$TEST_DIRECTORY/../$base
 720                # do not override scripts
 721                if test -x "$symlink_target" &&
 722                    test ! -d "$symlink_target" &&
 723                    test "#!" != "$(head -c 2 < "$symlink_target")"
 724                then
 725                        symlink_target=../valgrind.sh
 726                fi
 727                case "$base" in
 728                *.sh|*.perl)
 729                        symlink_target=../unprocessed-script
 730                esac
 731                # create the link, or replace it if it is out of date
 732                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 733        }
 734
 735        # override all git executables in TEST_DIRECTORY/..
 736        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 737        mkdir -p "$GIT_VALGRIND"/bin
 738        for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
 739        do
 740                make_valgrind_symlink $file
 741        done
 742        OLDIFS=$IFS
 743        IFS=:
 744        for path in $PATH
 745        do
 746                ls "$path"/git-* 2> /dev/null |
 747                while read file
 748                do
 749                        make_valgrind_symlink "$file"
 750                done
 751        done
 752        IFS=$OLDIFS
 753        PATH=$GIT_VALGRIND/bin:$PATH
 754        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 755        export GIT_VALGRIND
 756elif test -n "$GIT_TEST_INSTALLED" ; then
 757        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 758        error "Cannot run git from $GIT_TEST_INSTALLED."
 759        PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
 760        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 761else # normal case, use ../bin-wrappers only unless $with_dashes:
 762        git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
 763        if ! test -x "$git_bin_dir/git" ; then
 764                if test -z "$with_dashes" ; then
 765                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 766                fi
 767                with_dashes=t
 768        fi
 769        PATH="$git_bin_dir:$PATH"
 770        GIT_EXEC_PATH=$TEST_DIRECTORY/..
 771        if test -n "$with_dashes" ; then
 772                PATH="$TEST_DIRECTORY/..:$PATH"
 773        fi
 774fi
 775GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 776unset GIT_CONFIG
 777GIT_CONFIG_NOSYSTEM=1
 778GIT_CONFIG_NOGLOBAL=1
 779export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 780
 781. ../GIT-BUILD-OPTIONS
 782
 783if test -z "$GIT_TEST_CMP"
 784then
 785        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 786        then
 787                GIT_TEST_CMP="$DIFF -c"
 788        else
 789                GIT_TEST_CMP="$DIFF -u"
 790        fi
 791fi
 792
 793GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 794export GITPERLLIB
 795test -d ../templates/blt || {
 796        error "You haven't built things yet, have you?"
 797}
 798
 799if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 800then
 801        GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
 802        export GITPYTHONLIB
 803        test -d ../git_remote_helpers/build || {
 804                error "You haven't built git_remote_helpers yet, have you?"
 805        }
 806fi
 807
 808if ! test -x ../test-chmtime; then
 809        echo >&2 'You need to build test-chmtime:'
 810        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 811        exit 1
 812fi
 813
 814# Test repository
 815test="trash directory.$(basename "$0" .sh)"
 816test -n "$root" && test="$root/$test"
 817case "$test" in
 818/*) TRASH_DIRECTORY="$test" ;;
 819 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 820esac
 821test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 822rm -fr "$test" || {
 823        GIT_EXIT_OK=t
 824        echo >&5 "FATAL: Cannot prepare test area"
 825        exit 1
 826}
 827
 828test_create_repo "$test"
 829# Use -P to resolve symlinks in our working directory so that the cwd
 830# in subprocesses like git equals our $PWD (for pathname comparisons).
 831cd -P "$test" || exit 1
 832
 833this_test=${0##*/}
 834this_test=${this_test%%-*}
 835for skp in $GIT_SKIP_TESTS
 836do
 837        case "$this_test" in
 838        $skp)
 839                say_color skip >&3 "skipping test $this_test altogether"
 840                skip_all="skip all tests in $this_test"
 841                test_done
 842        esac
 843done
 844
 845# Provide an implementation of the 'yes' utility
 846yes () {
 847        if test $# = 0
 848        then
 849                y=y
 850        else
 851                y="$*"
 852        fi
 853
 854        while echo "$y"
 855        do
 856                :
 857        done
 858}
 859
 860# Fix some commands on Windows
 861case $(uname -s) in
 862*MINGW*)
 863        # Windows has its own (incompatible) sort and find
 864        sort () {
 865                /usr/bin/sort "$@"
 866        }
 867        find () {
 868                /usr/bin/find "$@"
 869        }
 870        sum () {
 871                md5sum "$@"
 872        }
 873        # git sees Windows-style pwd
 874        pwd () {
 875                builtin pwd -W
 876        }
 877        # no POSIX permissions
 878        # backslashes in pathspec are converted to '/'
 879        # exec does not inherit the PID
 880        ;;
 881*)
 882        test_set_prereq POSIXPERM
 883        test_set_prereq BSLASHPSPEC
 884        test_set_prereq EXECKEEPSPID
 885        ;;
 886esac
 887
 888test -z "$NO_PERL" && test_set_prereq PERL
 889test -z "$NO_PYTHON" && test_set_prereq PYTHON
 890
 891# test whether the filesystem supports symbolic links
 892ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
 893rm -f y